use btproto::protocol;
use serde::{Serialize, Deserialize};

use crate::{sector_proto::FileId, CallMsg, ActorName};

#[derive(Serialize, Deserialize)]
pub struct Open {
    id: FileId
}

impl CallMsg for Open {
    type Reply = ActorName;
}

protocol! {
    ServerInit?Activate -> Listening;

    Client -> Client, service(Listening)!Query;
    Listening?Query -> Listening, Client!Query::Reply;
    Client?Query::Reply -> Client;

    Client -> Client, service(Listening)!Open;
    Listening?Open -> Listening, Opened, Client!Open::Reply;
    Client?Open::Reply -> Client, FileHandle;

    FileInit?Activate -> FileInit;
    FileInit?Open -> Opened;

    FileHandle -> FileHandle, Opened!FileOp;
    Opened?FileOp -> Opened, Client!FileOp::Reply;
    FileClient?FileOp::Reply -> FileClient;

    FileClient -> End, Opened!Close;
    Opened?Close -> End;
}